<template>
  <section class="stream" :data-id="id">
    <EditFavorite @input="updateConfig" :name="name"/>

    <div class="container">
      <Searchbar @input="search" v-model="searchValue" :search-value="searchValue"/>
    </div>

    <div class="container">

      <div class="stream-header" v-if="tops.length">
        <h2>Breaking News</h2>
      </div>
      <div class="stream-wrapper -top" v-if="tops.length">
        <div class="left">
          <Article v-for="(n, index) in tops.slice(0, 2)" :news="n" :key="`${index}-top1`"/>
        </div>
        <div class="right">
          <Article v-for="(n, index) in tops.slice(2)" :news="n" :key="`${index}-top2`"/>
        </div>
      </div>


      <div class="stream-header">
        <h2>Articles</h2>
      </div>
      <div class="stream-wrapper">
        <div class="left">
          <ArticleBig v-for="(n, index) in stream.slice(0, 1)" :news="n" :key="`${index}-medium1`"/>
        </div>
        <div class="right">
          <Article v-for="(n, index) in stream.slice(1)" :news="n" :key="`${index}-medium2`"/>
        </div>
      </div>
      <div class="stream-empty" v-if="!stream.length">
        <p>No Articles. Try another search value.</p>
      </div>

    </div>
  </section>
</template>

<script>
import WebStorage from "@/utils/WebStorage";
import Icon from "@/components/Icon";
import Searchbar from "@/components/Searchbar";
import Article from "@/components/Article";
import ArticleBig from "@/components/articles/ArticleBig";
import ArticleLoading from "@/components/articles/ArticleLoading";
import EditFavorite from "../../components/EditFavorite";

export default {
  middleware: ['auth'],
  components: {EditFavorite, ArticleLoading, ArticleBig, Article, Searchbar, Icon},
  data() {
    return {
      newsCount: 0,
      promise: true,
      id: null
    }
  },
  computed: {
    stream() {
      return this.$store.getters['Stream/stream'];
    },
    tops() {
      return this.$store.getters['Stream/tops'];
    }
  },
  async asyncData({store, params, $axios, $rest, redirect}) {
    await store.dispatch('Stream/reset');
    let subscriptions = await $rest.Me.config.get();
    store.commit('Stream/UPDATE_SUBSCRIPTIONS', subscriptions);

    let config = store.getters['Stream/id'](params.id);

    if(!config) {
      redirect('/stream/create');
    }

    await store.dispatch('Stream/fetchStream', {  // fetch stream
      searchValue: config.searchValue,
      axios: $axios
    });

    return config;
  },
  methods: {
    async search(searchValue) {
      this.searchValue = searchValue;
      await this.$store.dispatch('Stream/fetchStream', {  // fetch stream
        searchValue,
        axios: this.$axios
      });
    },

    async updateConfig(data) {
      const subscriptions = await this.$rest.Me.config.set({
        id: this.id,
        name: data.favName,
        searchValue: this.searchValue
      });

      this.$store.commit('Stream/UPDATE_SUBSCRIPTIONS', subscriptions);
    }
  }
}
</script>
